/*
 *@(#)TaxInvoice.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.b2b.taxinvoice;

import iiixzu.b2b.IBusinessCertificate;
import iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceDetailsSchema;
import iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceSchema;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceDetailsSchema;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceSchema;
import iiixzu.help.Date;
import iiixzu.help.StringHelper;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;


/**
 * ݰ꼭. DB Ǿִ ݰ꼭/꼭    ִ.
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class TaxInvoice implements Serializable{
	
	private static final long serialVersionUID = -2338634063176550428L;
	
	/**
	 * 꼭-鼼.
	 */
    public static final String TAXTYPE_FREE="FREE";
    /**
     * ݰ꼭-.
     */
    public static final String TAXTYPE_LEVY="LEVY";
    /**
     * ݰ꼭-.
     */
    public static final String TAXTYPE_ZERO="ZERO";
    
    private String ݰ꼭ȣ;
    private Company ;
    private Company ޹޴;
    private String 鼼;
    private Date ۼ;
    private String ߱;
    private String ;
    private int ǰ;
    private int ;			
    private double ް;
    private double ;
    private double Ѿ;		
    private boolean isExist;
	
    transient private ITaxInvoiceSchema taxInvoiceSchema;
    transient private ITaxInvoiceDetailsSchema tradeListSchema;
	
    /**
	 * .⺻ ݰ꼭 DBŰ  ݰ꼭  Եȴ.
	 * @param taxInvoiceNumber 꼭ȣ
	 * @param con Connectionü.
	 * @throws TaxInvoiceException ݰ꼭 ý  ߻.
	 */
	public TaxInvoice(String taxInvoiceNumber,Connection con)
		throws TaxInvoiceException{	    
		this.init(taxInvoiceNumber,new DefaultTaxInvoiceSchema(),new DefaultTaxInvoiceDetailsSchema(),con);
	}
	TaxInvoice(String taxInvoiceNumber,ITaxInvoiceSchema taxInvoiceSchema,ITaxInvoiceDetailsSchema tradeListSchema,Connection con)
		throws TaxInvoiceException{
	    this.init(taxInvoiceNumber,taxInvoiceSchema,tradeListSchema,con);
	}
	/**
	 * ݰ꼭 ´.
	 * @param taxInvoiceNumber ݰ꼭ȣ.
	 * @param taxInvoiceSchema ݰ꼭DBŰ.
	 * @param tradeListSchema ŷDBŰ.
	 * @param con Connectionü.
	 * @throws TaxInvoiceException ݰ꼭   ߻.
	 */
	protected void init(String taxInvoiceNumber,ITaxInvoiceSchema taxInvoiceSchema,ITaxInvoiceDetailsSchema tradeListSchema,Connection con)
		throws TaxInvoiceException{
		    
	    this.taxInvoiceSchema=taxInvoiceSchema;
	    this.tradeListSchema=tradeListSchema;
	    
		PreparedStatement pstmt1=null;
		ResultSet resultSet1=null;
		
										//2
		String ="SELECT "+taxInvoiceSchema.getColumnSupplierName()+","+taxInvoiceSchema.getColumnSupplierRegistNumber()+"," +//1
									   taxInvoiceSchema.getColumnSupplierBusinessProprietor()+","+taxInvoiceSchema.getColumnSupplierPlaceOfBusiness()+","+//2
									   taxInvoiceSchema.getColumnSupplierTypeOfIndustry()+","+taxInvoiceSchema.getColumnSupplierBusinessConditions()+","+//3
									   taxInvoiceSchema.getColumnBuyerName()+","+taxInvoiceSchema.getColumnBuyerRegistNumber()+","+//4
									   taxInvoiceSchema.getColumnBuyerBusinessProprietor()+","+taxInvoiceSchema.getColumnBuyerPlaceOfBusiness()+","+//5
									   taxInvoiceSchema.getColumnBuyerTypeOfIndustry()+","+taxInvoiceSchema.getColumnBuyerBusinessConditions()+","+//6
									   taxInvoiceSchema.getColumnTaxInvoiceNumber()+","+taxInvoiceSchema.getColumnTaxType()+","+//7
									   taxInvoiceSchema.getColumnMakeDate()+","+taxInvoiceSchema.getColumnSubject()+","+//8
									   taxInvoiceSchema.getColumnTaxInvoiceItemCount()+","+taxInvoiceSchema.getColumnBlankCount()+","+//9
									   taxInvoiceSchema.getColumnSupplyAmount()+","+taxInvoiceSchema.getColumnTaxAmount()+","+//10
									   taxInvoiceSchema.getColumnTotalAmount()+","+taxInvoiceSchema.getColumnIssueDate()+" "+//11
						 "FROM "+taxInvoiceSchema.getTableTaxInvoice()+" "+							  
						 "WHERE "+taxInvoiceSchema.getColumnTaxInvoiceNumber()+"=? ";
		
		try {
			pstmt1=con.prepareStatement();
			pstmt1.setString(1,taxInvoiceNumber);			
			resultSet1=pstmt1.executeQuery();
			
			if(resultSet1.next()){				
			    =new Company();
			    //1
			    .ȸ=resultSet1.getString(1);
			    .ڵϹȣ=resultSet1.getString(2);
			    //2
			    .ǥڸ=resultSet1.getString(3);
			    .=resultSet1.getString(4);
			    //3
			    .=resultSet1.getString(5);
			    .=resultSet1.getString(6);
			    
			    ޹޴=new Company();
			    //4
			    ޹޴.ȸ=resultSet1.getString(7);
			    ޹޴.ڵϹȣ=resultSet1.getString(8);
			    //5
			    ޹޴.ǥڸ=resultSet1.getString(9);
			    ޹޴.=resultSet1.getString(10);
			    //6
			    ޹޴.=resultSet1.getString(11);
			    ޹޴.=resultSet1.getString(12);
			    //7
				this.ݰ꼭ȣ=resultSet1.getString(13);
			    this.鼼=resultSet1.getString(14);
			    //8
				String[] temp=StringHelper.stringTokenize(resultSet1.getString(15),"/");
				this.ۼ=new Date(Integer.parseInt(temp[0]),Integer.parseInt(temp[1]),Integer.parseInt(temp[2]));
				this.=resultSet1.getString(16);
				//9
				this.ǰ=resultSet1.getInt(17);
				this.=resultSet1.getInt(18);
				//10
				this.ް=resultSet1.getDouble(19);
				this.=resultSet1.getDouble(20);
				//11
				this.Ѿ=resultSet1.getDouble(21);
				this.߱=resultSet1.getString(22);
				
				this.isExist=true;
			}else{
				this.isExist=false;
			}			
		} catch (SQLException sqle) {
			throw new TaxInvoiceException(sqle);
		} catch (Exception e){
			throw new TaxInvoiceException(e);
		}finally{
			try{if(resultSet1!=null){resultSet1.close();}}catch(Exception e){}
			try{if(pstmt1!=null){pstmt1.close();}}catch(Exception e){}
		}
	}	
	/**
	 *  翩θ ´.
	 * @return true : Ͱ ,false : Ͱ .
	 */
	public boolean isExist(){
	    return isExist;
	}
	/**
	 * ݰ꼭  Ѵ. DB Ǿִ ݰ꼭 
	 * Ų. ̶  ü   ʴ´.
	 * 
	 * @param con Connectionü.
	 */
	public void delete(Connection con) throws SQLException,Exception{
		
		PreparedStatement pstmt1=null;
		PreparedStatement pstmt2=null;
		
		String query1="DELETE FROM "+this.taxInvoiceSchema.getTableTaxInvoice()+" " +
							"WHERE "+this.taxInvoiceSchema.getColumnTaxInvoiceNumber()+"=? ";
		String query2="DELETE FROM "+this.tradeListSchema.getTableTaxInvoiceDetails()+" " +
						 	"WHERE "+this.tradeListSchema.getColumnTaxInvoiceNumber()+"=? ";
		
		try{
			pstmt1=con.prepareStatement(query1);
			pstmt2=con.prepareStatement(query2);
			
			pstmt1.setString(1,this.ݰ꼭ȣ);
			pstmt2.setString(2,this.ݰ꼭ȣ);
			
			pstmt2.executeUpdate();
			if(pstmt1.executeUpdate()!=1){
				throw new Exception("#Occur exception during deleting TaxInvoice("+this.ݰ꼭ȣ+")");						
			}		
		} catch (SQLException e) {
			throw e;
		} catch(Exception e){
			throw e;
		}finally{
			try{if(pstmt1!=null){pstmt1.close();}}catch(Exception e){}
			try{if(pstmt2!=null){pstmt2.close();}}catch(Exception e){}
		}			
	}
	/**
	 * ݰ꼭 ϱ Ŭ ´. ݰ꼭 Ϻγ ϱ
	 * ؼ  ޼ҵ带 ̿ؼ EditTaxŬ Ѵ. 
	 * 
	 * @return ݰ꼭 Ŭ.
	 */
	public EditTax editTaxInvoice(){
	    EditTax editTax=new EditTax();
	    
	    editTax.taxInvoiceSchema=this.taxInvoiceSchema;
	    editTax.taxInvoiceNumber=this.ݰ꼭ȣ;
	    editTax.buyer=this.޹޴;
	    editTax.supplier=this.;
	    editTax.makeDate=this.ۼ;
	    editTax.supplyAmount=this.ް;
	    editTax.taxAmount=this.;
	    editTax.subject=this.;
	    
	    return editTax;
	}	
	/**
	 * ݰ꼭  Ѵ.  ݰ꼭 ߱޵ǰ  ߻
	 * 쿡 ϰ ߱ϴ° Ģ̶ ϳ   ׷ Ҽ
	 *   찡  ֱ⸶̴.  ׷ 찡 ߻쿡 getEditableTaxInvoice()
	 * ޼ҵ常     Ұ  Ƿ  ޼ҵ带 ؼ
	 * ݰ꼭    ִ.  ϱ⿡  ݰ꼭 ü
	 * Ӹƴ϶ ŷ  ٸ ΰ   ̴.  ̰ ʰ
	 * ٸ  ̿ص  . ;;;; 
	 * 
	 * @param editTaxInvoice ݰ꼭 ̽.
	 * @param con Connection ü.
	 * @throws TaxInvoiceException   ߻.
	 */
	public void editTaxInvoice(IEditTaxInvoice editTaxInvoice,Connection con)
		throws TaxInvoiceException{
	    editTaxInvoice.edit(this,con);
	}
	/**
	 *   ´.
	 * @return .
	 */
	public IBusinessCertificate getSupplier(){
	    return this.;
	}
	/**
	 * ޹޴  ´.
	 * @return ޹޴.
	 */
	public IBusinessCertificate getBuyer(){
	    return this.޹޴;
	}
	/**
	 * ݰ꼭ȣ ´.
	 * @return ݰ꼭ȣ.
	 */
	public String getTaxInvoiceNumber(){
		return this.ݰ꼭ȣ;
	}
	/**
	 * θ ´.
	 * @return .
	 * @see #TAXTYPE_FREE 鼼.
	 * @see #TAXTYPE_LEVY .
	 * @see #TAXTYPE_ZERO .
	 */
	public String getTaxType(){
		return this.鼼;
	}	
	/**
	 * ݰ꼭ۼ ´.
	 * @return ۼ.
	 */
	public Date getMakeDate(){
		return this.ۼ;
	}
	/**
	 *  ´.  23   · Ǿִ  ´.
	 * @return .
	 */
	public String getSubject(){
		return this.;
	}
	/**
	 * ǰ ´. ݰ꼭 ߱ϴµ  ǰ ̴.
	 * @return ǰ.
	 */
	public int getTaxInvoiceItemCount(){
		return this.ǰ;
	}
	/**
	 *  ´.
	 * @return .
	 */
	public int getEmptyCount(){
		return this.;
	}
	/**
	 * ް ´.
	 * @return ް.
	 */
	public double getSupplyAmount(){
		return this.ް;
	}
	/**
	 *  ´.  鼼ϰ쳪 ϰ 0 ̴.
	 * @return .
	 */
	public double getTaxAmount(){
		return this.;
	}
	/**
	 * Ѿ ´. ް+
	 * @return Ѿ.
	 */
	public double getTotalAmount(){
		return this.Ѿ;
	}
	private class Company implements IBusinessCertificate{
	    String ȸ;
	    String ڵϹȣ;
	    String ǥڸ;
	    String ;
	    String ;
	    String ;
	    /**
		 * ڵ ȸ ´.
		 * 
		 * @return ڵȸ.
		 */
		public String getRegistrationName(){
		    return this.ȸ;
		}
		/**
		 * ڵϹȣ ´. ڵ Ǿ ִ ڵϹȣ.
		 * (ιȣ ƴ϶ ڵϹȣ̾Ѵ)
		 * 
		 * @return ڵϹȣ.
		 */
		public String getRegistrationNumber(){
		    return this.ڵϹȣ;
		}
		/**
		 * ǥڸ ´. ڵ Ǿ ִ ǥڸ.
		 * 
		 * @return ǥڸ.
		 */
		public String getBusinessProprietor(){
		    return this.ǥڸ;
		}
		/**
		 *  ´. ڵ Ǿִ .
		 * 
		 * @return .
		 */
		public String getPlaceOfBusiness(){
		    return this.;
		}
		/**
		 *  ´. ڵ Ǿִ .
		 * 
		 * @return .
		 */
		public String getTypeOfIndustry(){
		    return this.;
		}
		/**
		 * ¸ ´.
		 * 
		 * @return . ڵ Ǿִ .
		 */
		public String getBusinessConditions(){
		    return this.;
		}
	}
}