/*
 *@(#)TaxInvoiceCreater.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.b2b.taxinvoice;

import iiixzu.b2b.IBusinessCertificate;
import iiixzu.b2b.taxinvoice.policy.DefaultTaxIssuePolicy;
import iiixzu.b2b.taxinvoice.policy.ITaxIssuePolicy;
import iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceDetailsSchema;
import iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceSchema;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceDetailsSchema;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceSchema;
import iiixzu.help.Date;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;


/**
 * ݰ꼭 ߱ޱ ϴ Ŭ. Ŭ ϳ ϳ ݰ꼭 
 * ް ȴ.
 * <p><pre>
 * 1) Ϲ ݰ꼭 ߱޽.
 * TaxInvoiceNumber invoiceNumber=new UserTaxInvoiceNumber("2005060600001");
 * Supplier supplier=new UserSupplier("޹޴ڸ","ڹȣ","");
 * Buyer buyer=new UserBuyer("ڸ","ڹȣ","");
 * Date date=new Date(2005,6,6);
 * 
 * TaxInvoiceCreater creater=new TaxInvoiceCreater(invoiceNumber,supplier,buyer,date,TaxInvoice.TAXTYPE_LEVY);               									
 * 
 * ----------------------------------------------------------------------------
 *   ߱å̳  DBŰ ϰѴٸ ̺κ Ѵ.
 * creater.setTaxInvoicePolicy(ڰ  ߱å);
 * creater.setTaxInvoiceSchema(ڰ  ݰ꼭 Ű);
 * creater.setTaxInvoiceDetailsSchema(ڰ  ŷŰ);
 * ----------------------------------------------------------------------------
 * 
 * ߱޳߰
 * -----------------------------------
 * creater.add(߱Ϸ³(ֹ)1);
 * creater.add(߱Ϸ³(ֹ)2);
 * 
 * ߱
 * -------------------
 * creater.create(con);
 * 
 * 2) ڼݰ꼭 ߱   ݰ꼭 ۼǴ ݰ꼭 ߱޽.
 * TaxInvoiceNumber invoiceNumber=new UserTaxInvoiceNumber("2005060600001");
 * Supplier supplier=new UserSupplier("޹޴ڸ","ڹȣ","");
 * Buyer buyer=new UserBuyer("ڸ","ڹȣ","");
 * Date date=new Date(2005,6,6);
 * 
 * TaxInvoiceCreater creater=new TaxInvoiceCreater(invoiceNumber,supplier,buyer,date,TaxInvoice.TAXTYPE_LEVY);               									
 * 
 * ߱å ݵ Ѵ.(ϴ    ֵ)
 * creater.setTaxInvoicePolicy(ڰ  ߱å);
 * 
 * ----------------------------------------------------------------------------
 *   DBŰ ϰѴٸ ̺κ Ѵ.
 * creater.setTaxInvoiceSchema(ڰ  ݰ꼭 Ű);
 * creater.setTaxInvoiceDetailsSchema(ڰ  ŷŰ);
 * ----------------------------------------------------------------------------
 * 
 * ߱
 * -------------------
 * creater.create(con);
 * 
 * </pre></p>
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class TaxInvoiceCreater {
	
	private List ߱޴;
		
	private ITaxInvoiceNumber 꼭ȣ;
	private IBusinessCertificate ;
	private IBusinessCertificate ޹޴;
	private ITaxInvoiceSchema ݰ꼭Ű;
	private ITaxInvoiceDetailsSchema ŷŰ;
	private ITaxIssuePolicy ݰ꼭߱å;
	private String 鼼;
	private Date ۼ;
	
	private String query1;
	private String query2;
	
	/**
	 * 꼭/꼭  ϵ Ѵ.
	 * @param taxInvoiceNumber ݰ꼭ȣ.
	 * @param supplier 
	 * @param buyer ޹޴
	 * @param makeDate ۼ
	 * @param taxType ݰ꼭(/鼼/){@link iiixzu.b2b.taxinvoice.TaxInvoice}
	 */
	public TaxInvoiceCreater(ITaxInvoiceNumber taxInvoiceNumber,IBusinessCertificate supplier,IBusinessCertificate buyer,Date makeDate,String taxType){
	    
	    this.߱޴=new ArrayList();
		this.꼭ȣ=taxInvoiceNumber;
		this.=supplier;
		this.޹޴=buyer;	    
		this.ۼ=makeDate;
		this.鼼=taxType;
		
		if(makeDate==null){
		    throw new NullPointerException("#makeDate is null");
		}
		if(taxType==null){
		    throw new NullPointerException("#taxType is null");
		}
		if(!(taxType.equals(TaxInvoice.TAXTYPE_FREE)||taxType.equals(TaxInvoice.TAXTYPE_LEVY)||taxType.equals(TaxInvoice.TAXTYPE_ZERO))){
		    throw new IllegalArgumentException("#taxType is invalid("+taxType+").");
		}
		if(taxInvoiceNumber==null){
		    throw new NullPointerException("#taxInvoiceNumber is null");
		}
		if(supplier==null){
		    throw new NullPointerException("#supplier is null");
		}
		if(buyer==null){
		    throw new NullPointerException("#buyer is null");
		}
		if(꼭ȣ.getTaxInvoiceNumber()==null||꼭ȣ.getTaxInvoiceNumber().trim().equals("")){
			throw new IllegalArgumentException("#TaxInvoiceNumber is not Exist("+꼭ȣ.getTaxInvoiceNumber()+").");
		}
	}	
	/**
	 * ݰ꼭 ҽ ʿ DBŰ Ѵ.  Ű
	 *   ʴ´ٸ ⺻ DBŰ {@link iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceSchema}
	 *  ̿ؼ  Ű  ϰ ȴ.
	 * 
	 * @param schema ̺Ű̽(ݰ꼭 ߱ ѹ ϴ).
	 */
	public void setTaxInvoiceSchema(ITaxInvoiceSchema schema){
	    if(this.ݰ꼭Ű==null){
	        this.ݰ꼭Ű=schema;
	    }else{
	        throw new IllegalArgumentException("#Already ITaxInvoiceSchema is Set!!");
	    }
	}
	/**
	 * ݰ꼭  ΰ Ǵ ŷ DBŰ Ѵ. 
	 *  Ű  ʴ´ٸ ⺻ DBŰ{@link iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceDetailsSchema}
	 *  ̿Ͽ Ű ϰԵȴ.
	 * 
	 * @param schema ŷŰ(ݰ꼭 ߱ ѹ ϴ)
	 */
	public void setTaxInvoiceDetailsSchema(ITaxInvoiceDetailsSchema schema){
	    if(this.ŷŰ==null){
	        this.ŷŰ=schema;
	    }else{
	        throw new IllegalArgumentException("#Already ITaxTradeListSchema is Set!!");
	    }
	}
	/**
	 * ݰ꼭 ߱å Ѵ.    ٸ ݰ꼭 ߱޽ 
	 *  ݰ꼭 ߱å{@link iiixzu.b2b.taxinvoice.policy.DefaultTaxIssuePolicy}
	 *  ̿ϰԵȴ. ݰ꼭 ߱å add(ITaxInvoiceItem item) ޼ҵ尡 
	 * Ǳ  Ǿ ϸ  ׷ʴٸ ⺻ ݰ꼭 ߱å 
	 *  ȴ.
	 * 
	 * @param policy ݰ꼭 ߱å(ѹ ϴ)
	 */
	public void setTaxInvoicePolicy(ITaxIssuePolicy policy){
	    if(this.ݰ꼭߱å==null){
	        this.ݰ꼭߱å=policy;
	    }else{
	        throw new IllegalArgumentException("#Already ITaxInvoicePolicy is Set!!");
	    }
	}
	/**
	 * 꼭 ߱޴ ߰Ų.
	 * @param item ݰ꼭 ߱޴.
	 */
	public void add(ITaxInvoiceItem item){
	    if(this.ݰ꼭߱å==null){
	        this.ݰ꼭߱å=new DefaultTaxIssuePolicy();
	    }
	    ߱޴.add(item);
	    this.ݰ꼭߱å.add(item);
	}
	/**
	 * ̸ .    ؼ ݰ꼭  
	 * ޵Ǵ ˾ƾ 찡 ִ.  ȭ鿡 õ ֹ 
	 * ؼ ̸ ݰ꼭  óǴ Ȯϰ  ߱ ϴ
	 * 찡  ̷ ϼ ִ ̴.
	 * <p> 
	 * <b>  ʴ´.(ʿ伺θ (?) ..)</b>
	 * </p>
	 * 
	 * @return ݰ꼭 Ŭ.
	 */
	public TaxInvoice getPreview(){
	    return null;
	}
	/**
	 * 꼭  Ѵ.
	 * ڿ  ״ ŸϽô Ÿ
	 * Ͻô add ߱޴ ľؼ Ȥ  Ѵ.
	 * @param con Connectionü.
	 * @return ߱޵ ݰ꼭ȣ
	 * @throws TaxInvoiceCreateException ݰ꼭 ߱޽ù ߻ .
	 */
	public String create(Connection con) throws TaxInvoiceCreateException{
		
	    
		PreparedStatement pstmt1=null;
		PreparedStatement pstmt2=null;
						
		try {
			//ܰó..
			this.preCheck();
							 
			if(ݰ꼭߱å.getSupplyAmount()!=0){
				pstmt1=con.prepareStatement(query1);
				pstmt2=con.prepareStatement(query2);
				
				pstmt1.setString(1,꼭ȣ.getTaxInvoiceNumber());
				pstmt1.setString(2,this.鼼);
				pstmt1.setString(3,this.ۼ.getDate("/","/",""));
				pstmt1.setString(4,getSubject(ݰ꼭߱å));
				pstmt1.setInt(5,߱޴.size());
				if(this.鼼.equals(TaxInvoice.TAXTYPE_LEVY)){
				    pstmt1.setInt(6,this.getBlankCount(ݰ꼭߱å.getSupplyAmount()+ݰ꼭߱å.getTaxAmount()+""));		
				    pstmt1.setDouble(7,ݰ꼭߱å.getSupplyAmount());				
				    pstmt1.setDouble(8,ݰ꼭߱å.getTaxAmount());
				    pstmt1.setDouble(9,ݰ꼭߱å.getSupplyAmount()+ݰ꼭߱å.getTaxAmount());
				}else{
				    pstmt1.setInt(6,this.getBlankCount(ݰ꼭߱å.getSupplyAmount()+""));		
				    pstmt1.setDouble(7,ݰ꼭߱å.getSupplyAmount());				
				    pstmt1.setDouble(8,0);
				    pstmt1.setDouble(9,ݰ꼭߱å.getSupplyAmount());
				}
				pstmt1.setTimestamp(10,new Timestamp(System.currentTimeMillis()));
				//..
				pstmt1.setString(11,.getRegistrationName());
				pstmt1.setString(12,.getRegistrationNumber());
				pstmt1.setString(13,.getBusinessProprietor());
				pstmt1.setString(14,.getPlaceOfBusiness());
				pstmt1.setString(15,.getTypeOfIndustry());
				pstmt1.setString(16,.getBusinessConditions());			
				//޹޴..
				pstmt1.setString(17,޹޴.getRegistrationName());
				pstmt1.setString(18,޹޴.getRegistrationNumber());
				pstmt1.setString(19,޹޴.getBusinessProprietor());
				pstmt1.setString(20,޹޴.getPlaceOfBusiness());
				pstmt1.setString(21,޹޴.getTypeOfIndustry());
				pstmt1.setString(22,޹޴.getBusinessConditions());
						
				ITaxInvoiceItem object=null;
				
				for(int i=0;i<߱޴.size();i++){
					object=(ITaxInvoiceItem)߱޴.get(i);
					
					pstmt2.setString(1,꼭ȣ.getTaxInvoiceNumber());
					pstmt2.setString(2,object.getIssueDivisionCode());
					pstmt2.setString(3,object.getName());
					pstmt2.setDouble(4,object.getUnitPrice());
					pstmt2.setDouble(5,object.getQuantity());
					pstmt2.setString(6,object.getUnitOfMeasure());
					
					pstmt2.addBatch();
				}
				
				pstmt1.executeUpdate();
				pstmt2.executeBatch();
			
				return 꼭ȣ.getTaxInvoiceNumber();
			}else{
				throw new Exception("#TaxInvoice Info is Invalid");
			}			
		} catch (Exception e){
			throw new TaxInvoiceCreateException(e.toString());
		}finally{
			try{if(pstmt1!=null){pstmt1.close();}}catch(Exception e){}
			try{if(pstmt2!=null){pstmt2.close();}}catch(Exception e){}		
		}
	}
	/**
	 * 꼭 ߱۾ ʱ۾.
	 */
	private void preCheck(){
	    if(ݰ꼭Ű==null){
	        this.ݰ꼭Ű=new DefaultTaxInvoiceSchema();
	    }
	    query1="INSERT INTO "+ݰ꼭Ű.getTableTaxInvoice()+"(" +
										  ݰ꼭Ű.getColumnTaxInvoiceNumber()+"," +
										  ݰ꼭Ű.getColumnTaxType()+"," +
										  ݰ꼭Ű.getColumnMakeDate()+"," +
										  ݰ꼭Ű.getColumnSubject()+"," +
										  ݰ꼭Ű.getColumnTaxInvoiceItemCount()+"," +
										  ݰ꼭Ű.getColumnBlankCount()+"," +
										  ݰ꼭Ű.getColumnSupplyAmount()+"," +
										  ݰ꼭Ű.getColumnTaxAmount()+"," +
										  ݰ꼭Ű.getColumnTotalAmount()+"," +
										  ݰ꼭Ű.getColumnIssueDate()+","+
										  ݰ꼭Ű.getColumnSupplierName()+","+
										  ݰ꼭Ű.getColumnSupplierRegistNumber()+","+
										  ݰ꼭Ű.getColumnSupplierBusinessProprietor()+","+
										  ݰ꼭Ű.getColumnSupplierPlaceOfBusiness()+","+
										  ݰ꼭Ű.getColumnSupplierTypeOfIndustry()+","+
										  ݰ꼭Ű.getColumnSupplierBusinessConditions()+","+
										  ݰ꼭Ű.getColumnBuyerName()+","+
										  ݰ꼭Ű.getColumnBuyerRegistNumber()+","+
										  ݰ꼭Ű.getColumnBuyerBusinessProprietor()+","+
										  ݰ꼭Ű.getColumnBuyerPlaceOfBusiness()+","+
										  ݰ꼭Ű.getColumnBuyerTypeOfIndustry()+","+
										  ݰ꼭Ű.getColumnBuyerBusinessConditions()+") "+
				  "VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";		
	    	
	    	if(this.ŷŰ==null){
	    	    this.ŷŰ=new DefaultTaxInvoiceDetailsSchema();
	    	}
	    	query2="INSERT INTO "+ŷŰ.getTableTaxInvoiceDetails()+"(" +
	    								      ŷŰ.getColumnTaxInvoiceNumber()+"," +
	    								      ŷŰ.getColumnOrderCode()+","+
	    								      ŷŰ.getColumnItemName()+","+
	    								      ŷŰ.getColumnUnitPrice()+","+
	    								      ŷŰ.getColumnQuantity()+","+
	    								      ŷŰ.getColumnUnitOfMeasure()+") "+
	    				"VALUES(?,?,?,?,?,?)";
	}
	/**
	 *  ´. )  23
	 * @param policy å.
	 * @return .
	 */
	private String getSubject(ITaxIssuePolicy policy){
		if(߱޴.size()>1){
		    return policy.getSubject()+" "+(߱޴.size()-1)+"";
		}else{
			return policy.getSubject();
		}
	}
	/**
	 * ݰ꼭  ´.
	 * empty_field 
	 * @param input  ˻ .
	 * @return .	 
	 */
	private int getBlankCount(String input) {
		return 14-input.length();
	}
}
