/*
 *@(#)TaxInvoiceManager.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.b2b.taxinvoice;

import iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceDetailsSchema;
import iiixzu.b2b.taxinvoice.schema.DefaultTaxInvoiceSchema;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceDetailsSchema;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceSchema;

import java.sql.Connection;

/**
 * ݰ꼭  ִ Ŭ.  ⺻ݰ꼭Ű  ݰ
 *    ʾ 쿡  Ŭ ̿Ͽ ݰ꼭 Ŭ
 *  ̿   ִ. ݰ꼭 Ű ڷμ   ְ 
 * ޼ҵ带 ̿Ͽ Ͽ  ִ.
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class TaxInvoiceManager {
    
    private ITaxInvoiceSchema taxInvoiceSchema;
    private ITaxInvoiceDetailsSchema taxTradeListSchema;
    
    /**
     * . ⺻ Ű  üθ.
     */
    public TaxInvoiceManager(){
        taxInvoiceSchema=new DefaultTaxInvoiceSchema();
        taxTradeListSchema=new DefaultTaxInvoiceDetailsSchema();
    }
    /**
     * . ڰ  Ű   ü .
     * @param taxInvoiceSchema ݰ꼭 Űü.
     * @param taxTradeListSchema ŷ Űü.
     */
    public TaxInvoiceManager(ITaxInvoiceSchema taxInvoiceSchema,ITaxInvoiceDetailsSchema taxTradeListSchema){
        setTaxInvoiceSchema(taxInvoiceSchema);
        setTaxTradeListSchema(taxTradeListSchema);
    }
    /**
     * ݰ꼭  ´.  Ŭ ų ڷ  Ű Ȥ
     * Ŀ  Ű ؼ ͸ ´.
     * 
     * @param taxInvoiceNumber ݰ꼭 ȣ.
     * @param con Connection ü.
     * @return ݰ꼭ü. ʴ´ٸ null Ѵ.
     * @throws TaxInvoiceException ݰ꼭 ü   ߻.
     */
    public TaxInvoice getTaxInvoice(String taxInvoiceNumber,Connection con)
    	throws TaxInvoiceException{
        TaxInvoice taxInvoice=new TaxInvoice(taxInvoiceNumber,taxInvoiceSchema,taxTradeListSchema,con);
        if(taxInvoice.isExist()){
            return taxInvoice;
        }else{
            return null;
        }
    }
    /**
	 * ݰ꼭 ȸ ʿ DBŰ Ѵ. 
	 * 
	 * @param schema ̺Ű̽.
	 */
	public void setTaxInvoiceSchema(ITaxInvoiceSchema schema){
	    if(schema==null){
	        throw new NullPointerException("#ITaxInvoiceSchema is null");
	    }else{
	        this.taxInvoiceSchema=schema;
	    }
	}
	/**
	 * ݰ꼭 ȸ ʿ ŷ DBŰ Ѵ.
	 * 	 * 
	 * @param schema ŷŰ.
	 */
	public void setTaxTradeListSchema(ITaxInvoiceDetailsSchema schema){
	    if(schema==null){
	        throw new NullPointerException("#ITaxTradeListSchema is null");
	    }else{
	        this.taxTradeListSchema=schema;
	    }
	}
}
