/*
 *@(#)DefaultTaxInvoiceSchema.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.b2b.taxinvoice.schema;


/**
 * ⺻ ݰ꼭 DBŰ.
 * <p><pre>
 * ) ̺(Ŭ)
 *  
 * create table tax_invoice
 * ( 
 *    tax_invoice_number                   varchar2(20) primary key,
 *    tax_type                                   varchar2(10),--10 Ѵ.
 *    supplier_name                           varchar2(255),--ȸ  ȸ .
 *    supplier_regist_number               varchar2(12),
 *    supplier_business_proprietor       varchar2(255),--ǥڸ ѱ̸θ  ܱ CEO ִ.
 *    supplier_placeof_business          varchar2(255),
 *    supplier_typeof_industry             varchar2(255),-- ¥ȸ . ٴ Ⱦ
 *    supplier_business_conditions     varchar2(255),--´  ٴ ª
 *    buyer_name                              varchar2(255),
 *    buyer_regist_number                  varchar2(12),
 *    buyer_business_proprietor         varchar2(255),
 *    buyer_placeof_business            varchar2(255),
 *    buyer_typeof_industry                varchar(255),
 *    buyer_business_conditions        varchar2(255),
 *    make_date                                varchar2(10), --ݵ 10ڸ .
 *    blank_count                              varchar2(10),
 *    supply_amount                          number(15),
 *    tax_amount                               number(15),
 *    total_amount                             number(15),
 *    subject                                     varchar2(255),
 *    tax_invoice_item_count              number(10),
 *    issue_date                                date
 * )
 * </pre><p>
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class DefaultTaxInvoiceSchema implements ITaxInvoiceSchema {
    /**
     * ݰ꼭 ̺  ´.
     * @return ݰ꼭̺.
     */
    public String getTableTaxInvoice(){
        return "tax_invoice";
    }
    /**
	 *  ڵ ȸ ÷ ´.
	 * 
	 * @return ڻڵȸ÷.
	 */
	public String getColumnSupplierName(){
	    return "supplier_name";
	}
	/**
	 *  ڵϹȣ ÷ ´.
	 * 
	 * @return ڻڵϹȣ÷.
	 */
	public String getColumnSupplierRegistNumber(){
	    return "supplier_regist_number";
	}
	/**
	 *  ǥڸ÷ ´.
	 * 
	 * @return ڴǥڸ÷.
	 */
	public String getColumnSupplierBusinessProprietor(){
	    return "supplier_business_proprietor";
	}
	/**
	 *  ÷ ´.
	 * 
	 * @return ڻ÷.
	 */
	public String getColumnSupplierPlaceOfBusiness(){
	    return "supplier_placeof_business";
	}
	/**
	 * ھ÷ ´.
	 * 
	 * @return ھ÷.
	 */
	public String getColumnSupplierTypeOfIndustry(){
	    return "supplier_typeof_industry";
	}
	/**
	 * ھ÷ ´.
	 * 
	 * @return ھ÷.
	 */
	public String getColumnSupplierBusinessConditions(){
	    return "supplier_business_conditions";
	}
	/**
	 * ޹޴ ڵ ȸ ÷ ´.
	 * 
	 * @return ޹޴ڻڵȸ÷.
	 */
	public String getColumnBuyerName(){
	    return "buyer_name";
	}
	/**
	 * ޹޴ ڵϹȣ ÷ ´.
	 * 
	 * @return ޹޴ڻڵϹȣ÷.
	 */
	public String getColumnBuyerRegistNumber(){
	    return "buyer_regist_number";
	}
	/**
	 * ޹޴ ǥڸ÷ ´.
	 * 
	 * @return ޹޴ڴǥڸ÷.
	 */
	public String getColumnBuyerBusinessProprietor(){
	    return "buyer_business_proprietor";
	}
	/**
	 * ޹޴ ÷ ´.
	 * 
	 * @return ޹޴ڻ÷.
	 */
	public String getColumnBuyerPlaceOfBusiness(){
	    return "buyer_placeof_business";
	}
	/**
	 * ޹޴ھ÷ ´.
	 * 
	 * @return ޹޴ھ÷.
	 */
	public String getColumnBuyerTypeOfIndustry(){
	    return "buyer_typeof_industry";
	}
	/**
	 * ޹޴ھ÷ ´.
	 * 
	 * @return ޹޴ھ÷.
	 */
	public String getColumnBuyerBusinessConditions(){
	    return "buyer_business_conditions";
	}
	/**
	 * ݰ꼭ȣ ÷ ´.
	 * 
	 * @return ݰ꼭ȣ ÷.
	 */
	public String getColumnTaxInvoiceNumber(){
	    return "tax_invoice_number";
	}	
	/**
	 * ݰ꼭 ۼ ÷ ´.
	 * 
	 * @return ݰ꼭ۼ÷.
	 */
	public String getColumnMakeDate(){
	    return "make_date";
	}
	/**
	 * ݰ꼭 ߱ ÷ ´.
	 * @return ݰ꼭 ߱÷.
	 */
	public String getColumnIssueDate(){
	    return "issue_date";
	}
	/**
	 * ް ÷ ´.
	 * 
	 * @return ް÷.
	 */
	public String getColumnSupplyAmount(){
	    return "supply_amount";
	}
	/**
	 *  ÷ ´.
	 * 
	 * @return ÷.
	 */
	public String getColumnTaxAmount(){
	    return "tax_amount";
	}
	/**
	 * Ѿ ÷ ´.
	 * 
	 * @return Ѿ÷.
	 */
	public String getColumnTotalAmount(){
	    return "total_amount";
	}
	/**
	 * 鼼 ÷ ´.
	 * 
	 * @return 鿵÷.
	 */
	public String getColumnTaxType(){
	    return "tax_type";
	}
	/**
	 * ÷ ´.
	 * 
	 * @return ÷.
	 */
	public String getColumnSubject(){
	    return "subject";
	}
	/**
	 * ǰ÷ ´.
	 * 
	 * @return ǰ÷.
	 */
	public String getColumnTaxInvoiceItemCount(){
	    return "tax_invoice_item_count";
	}
	/**
	 *  ÷ ´.
	 * 
	 * @return ÷.
	 */
	public String getColumnBlankCount(){
	    return "blank_count";
	}
}
