/*
 *@(#)EditTax.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.b2b.taxinvoice;

import iiixzu.b2b.IBusinessCertificate;
import iiixzu.b2b.taxinvoice.schema.ITaxInvoiceSchema;
import iiixzu.help.Date;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/**
 * ݰ꼭  ʿ ڰ̴. ϰ ϴ 뿡 ؼ  
 * ְ ޼ҵ带 ȣϰԵǸ ϰ   ؼ 泻 
 * DB ǰԵȴ. ̶ ݰ꼭 Ŭ ü   Ƿ 
 * Ȱ ؼ ش ݰ꼭 Ŭ̿ؼ ٽ ͸ ;Ѵ.
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class EditTax {
	
	String taxInvoiceNumber;
	
	Date makeDate;
	double supplyAmount;
	double taxAmount;
	String subject;
	IBusinessCertificate supplier;
	IBusinessCertificate buyer;
	
	ITaxInvoiceSchema taxInvoiceSchema;	
	/**
	 * ڴdefault Ǿ.
	 */
	EditTax(){	    
	}	
	/**
	 *   DB ݿŲ.   ۾   ޼ҵ带 ̿
	 * ϰ ȴٸ ƹ  Եȴ( DB ۾ Ͼ).
	 * 
	 * @param con Connection ü.
	 * @throws TaxInvoiceException ۾  ߻Ǿ ߻ȴ.
	 */
	public void commit(Connection con) throws TaxInvoiceException{
	    
	    PreparedStatement pstmt1=null;
	    
		String query="UPDATE "+taxInvoiceSchema.getTableTaxInvoice()+" " +
						   "SET "+taxInvoiceSchema.getColumnSupplierName()+"=?," +
						   		     taxInvoiceSchema.getColumnSupplierRegistNumber()+"=?," +
						   		     taxInvoiceSchema.getColumnSupplierBusinessProprietor()+"=?," +
						   		     taxInvoiceSchema.getColumnSupplierPlaceOfBusiness()+"=?," +
						   		     taxInvoiceSchema.getColumnSupplierTypeOfIndustry()+"=?," +
						   		     taxInvoiceSchema.getColumnSupplierBusinessConditions()+"=?," +
						   		     taxInvoiceSchema.getColumnBuyerName()+"=?," +
						   		     taxInvoiceSchema.getColumnBuyerRegistNumber()+"=?," +
						   		     taxInvoiceSchema.getColumnBuyerBusinessProprietor()+"=?," +
						   		     taxInvoiceSchema.getColumnBuyerPlaceOfBusiness()+"=?," +
						   		     taxInvoiceSchema.getColumnBuyerTypeOfIndustry()+"=?," +
						   		     taxInvoiceSchema.getColumnBuyerBusinessConditions()+"=?," +
						   		     taxInvoiceSchema.getColumnMakeDate()+"=?," +
						   		     taxInvoiceSchema.getColumnSubject()+"=?," +
						   		     taxInvoiceSchema.getColumnSupplyAmount()+"=?," +
						   		     taxInvoiceSchema.getColumnTaxAmount()+"=?," +
						   		     taxInvoiceSchema.getColumnTotalAmount()+"=? "+
							"WHERE "+taxInvoiceSchema.getColumnTaxInvoiceNumber()+"=? ";
		try{
			pstmt1=con.prepareStatement(query);
			
			pstmt1.setString(1,supplier.getRegistrationName());
			pstmt1.setString(2,supplier.getRegistrationNumber());
			pstmt1.setString(3,supplier.getBusinessProprietor());
			pstmt1.setString(4,supplier.getPlaceOfBusiness());
			pstmt1.setString(5,supplier.getTypeOfIndustry());
			pstmt1.setString(6,supplier.getBusinessConditions());
			
			pstmt1.setString(7,buyer.getRegistrationName());
			pstmt1.setString(8,buyer.getRegistrationNumber());
			pstmt1.setString(9,buyer.getBusinessProprietor());
			pstmt1.setString(10,buyer.getPlaceOfBusiness());
			pstmt1.setString(11,buyer.getTypeOfIndustry());
			pstmt1.setString(12,buyer.getBusinessConditions());

			pstmt1.setString(13,makeDate.getDate("/","/",""));
			pstmt1.setString(14,subject);
			pstmt1.setDouble(15,supplyAmount);
			pstmt1.setDouble(16,taxAmount);
			pstmt1.setDouble(17,supplyAmount+taxAmount);
			
			pstmt1.setString(18,taxInvoiceNumber);			
			
			int result=pstmt1.executeUpdate();			
			if(result!=1){
				throw new Exception("#Occur exception during editing TaxInvoice("+taxInvoiceNumber+")");						
			}		
		} catch (SQLException e) {
			throw new TaxInvoiceException(e);
		} catch(Exception e){
			throw new TaxInvoiceException(e);
		}finally{
			try{if(pstmt1!=null){pstmt1.close();}}catch(Exception e){}
		}
	}
	/**
	 *   Ѵ.
	 * @param supplier .
	 */
	public void setSupplier(IBusinessCertificate supplier){
	    if(supplier==null){
	        throw new NullPointerException("#supplier is null");
	    }
	    this.supplier=supplier;
	}
	/**
	 * ޹޴  Ѵ.
	 * @param buyer ޹޴.
	 */
	public void setBuyer(IBusinessCertificate buyer){
	    if(buyer==null){
	        throw new NullPointerException("#buyer is null");
	    }
	    this.buyer=buyer;
	}
	/**
	 *  ٲ۴. 00 00  õ  ٲٰԵȴ.
	 * @param subject  .
	 */
	public void setSubject(String subject) {
		this.subject = subject;
	}

	/**
	 * ۼ Ѵ.
	 * @param date  ۼ.
	 */
	public void setMakeDate(Date date) {
		makeDate = date;
	}
	/**
	 * ް Ѵ.
	 * @param supplyAmount  ް.
	 */
	public void setSupplyAmount(double supplyAmount) {
		this.supplyAmount = supplyAmount;
	}
	/**
	 *  Ѵ.
	 * 鼼 /ϰ쿡 ʴ´.
	 * @param taxAmount  .
	 */
	public void setTaxAmount(double taxAmount) {
		this.taxAmount=taxAmount;		
	}
}
