/*
 *@(#)Type2TaxIssuePolicy.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.b2b.taxinvoice.policy;

import iiixzu.b2b.taxinvoice.ITaxInvoiceItem;
import iiixzu.help.DataFormat;

/**
 * ݰ꼭 ߱å. ̹ ܰ  ݿ ǰ ؼ ݰ꼭߱޽
 * ̰ԵǴ ߱å̴.  ⿡ ̿Ǵ ܰ Ҽ ִ°Ϳ ؼ
 *   Ȯ  ʴ´.( ܰ ΰ ԵȰ쿡 
 * Ҽϰ ִ κ  ̴.  ̺κ ʿϴٸ  ϶)
 *  ̷ ݰ꼭   Ȯ  ִ° 
 * ǰ  ޴     ̴.
 * 
 * <p><pre>
 * 1. Ե ܰ Է 
 * 2.Ե ܰ  ؾ 10%
 * 3.ǥǰ  ū ǰ  Ѵ.
 * 4.ŷ ʱԷ°(԰) ǥõȴ.
 * </pre></p>
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class Type2TaxIssuePolicy implements ITaxIssuePolicy {
    
    private double Ѱް;
    private double Ѽ;
    private double ǥǰǰް;
    private String ;
    /**
     * ݰ꼭 ߱޴ ߰Ų. ݰ꼭 ߱޴μ Էµ ڷ 
     *  ް/׵ ϴ ڷ ̰Եȴ.
     * 
     * @param item ܰ  Ե item.
     */
    public void add(ITaxInvoiceItem item){
        
        double ܴܰ=Long.parseLong(DataFormat.format(item.getUnitPrice()/1.1,"####################"));
        double =item.getUnitPrice()-ܴܰ;
      
        double ް=ܴܰ*item.getQuantity();
        Ѱް+=ް;
        Ѽ+=*item.getQuantity();    
        if(ް>this.ǥǰǰް){
            =item.getName();
            this.ǥǰǰް=ް;
        }
    }
    /**
     * ް Ѿ ´.ް Ѿ տ ̴.
     * @return ް.
     */
    public double getSupplyAmount(){
        return (long)Ѱް;
    }
    /**
     *  Ѿ ´. Ѿ ռ  ̴.
     * ݰ꼭 ߱޽  ƴѰ쿡 ̿ ʴ´.
     * @return .
     */
    public double getTaxAmount(){
        return (long)Ѽ;
    }
    /**
     *  ´.   ū ǰ ȯѴ.
     * @return ǥǰ.
     */
    public String getSubject(){
        return this.;
    }
    /**
     * ܰ ԵȰ 10%   ܰ ؼ Ѱش.
     * ŷ Է° ԵǴ ׿ ؼ ȭ鿡 ܴܰ ǥ
     *   ̰ ̿  ִ.
     * 
     * @param unitPrice Դܰ.
     * @return  ܴ ܰ.
     */
    public static double getUnitPrice(double unitPrice){
        return Long.parseLong(DataFormat.format(unitPrice/1.1,"####################")); 
    }
}
