/*
 *@(#)StringTokenizer.java 
 *Copyright (C) 2005 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */
package iiixzu.help;

import java.util.Enumeration;
import java.util.Vector;
/**
 * StringTokenizer.  StringTokenizer Ϻλ ״.    
 * StringTokenizer delimeter "23" شٸ 23  ڿ ڸ 2ε ڸ 3ε 
 * ڸ ̳ StringTokenizer 23 delimeter ־ٸ 23θ ڿ
 *  ڸԵȴ. ̰ Ŀ ڹٿ spilt   ϴ  ˰ԵǾ.
 *  ׳ ϱ .
 * <p><pre>
 *  1) 츮||||||̷
 *         String[0] : 츮
 *         String[1] : 
 *         String[2] : 
 *         String[3] : ̷
 *  2)  ||츮||||||̷||
 *         String[0] : ""(ڿ)
 *         String[1] : 츮
 *         String[2] : 
 *         String[3] : 
 *         String[4] : ̷
 *         String[5] : ""(ڿ)
 *  3) 츮||||||||̷
 *         String[0] : 츮
 *         String[1] : 
 *         String[2] : ""(ڿ)
 *         String[3] : 
 *         String[4] : ̷
 * </pre></p>
 * Ư¡δ   ʰϴ nextToken() Ȥ nextElement() ȣߴ ϴ
 * <code>ArrayIndexOutOfBoundsException</code> ߻ ʰ ڿ "" ȯȴ..
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class StringTokenizer implements Enumeration{
	
	private String[] tokens;
	private int position;
	/**
	 * ־ ڿ ־ delimeter .
	 */
	public StringTokenizer(String str,String delim){
	
		Vector list=new Vector();
		
		int patternLength=delim.length();
		
		while(str.indexOf(delim)!=-1){
			list.addElement(str.substring(0,str.indexOf(delim)));
			str = str.substring(str.indexOf(delim)+patternLength, str.length()) ;
			if(str.indexOf(delim)==-1) {
				list.addElement(str);
			}
		}
		if(list.size()==0){
			tokens = new String[1];
			tokens[0] = new String(str);			
		}else{
			tokens = new String[list.size()];
			for(int i=0;i<list.size();i++){
				//ϰ쿡 ""ڿ Ѱش.
				tokens[i]=list.elementAt(i)==null?"":(String)list.elementAt(i);
			}
		}	
		position=-1;
	}
	/**
	 * ū  ´.
	 * @return int ū .
	 */
	public int countTokens(){
		return tokens.length;
	}
	/**
	 *  ū ȿ(ϰ) ľѴ.
	 * @return boolean true:ȿ false Ұ
	 */
	public boolean hasMoreTokens(){
		if(tokens.length>=(position+1)){
			return true;
		}else{
			return false;
		}				
	}
	/**
	 * ū ´.
	 *  ʰϴ ū½ ڿ ȯȴ.
	 * @return String ū
	 */
	public String nextToken(){
		try {
			position++;
			return tokens[position];
		} catch (ArrayIndexOutOfBoundsException aiobe) {
			return "";
		}
	}
	/**
	 *  Element ȿ(ϰ) ľѴ.
	 * Enumeration.
	 * @return boolean true:ȿ false Ұ
	 */	
	public boolean hasMoreElements(){
		if(tokens.length>=(position+1)){
			return true;
		}else{
			return false;
		}				
	}
	/**
	 * Element ´.
	 *  ʰϴ Element½ ڿ ȯȴ.
	 * Enumeration.
	 * @return String Element
	 */
	public Object nextElement(){
		try {
			position++;
			return tokens[position];
		} catch (ArrayIndexOutOfBoundsException aiobe) {
			return "";
		}
	}
}
