/*
 *@(#)SqlHelper.java
 *Copyright (C) 2006 Lee,Gyujoo - MAILTO:iiixzu@gmail.com
 *
 * α׷  ƮԴϴ; Ʈ Ǿ絵ڴ  Ʈ  ǥ GNU Ϲ 
 *  㰡 2 Ǵ    Ƿ ؼ,    α׷ ϰų   
 * ֽϴ. 
 *
 * α׷ ϰ     ǰ , Ư  ´ ռ  
 * Ǹſ           ʽϴ;  
 * ڼ ׿ ؼ GNU Ϲ   㰡 Ͻñ ٶϴ. 
 *
 *GNU Ϲ   㰡  α׷ Բ ˴ϴ; ,   Ǿ ִٸ   
 *Ʈ  Ͻñ ٶϴ. ( Ʈ :  Free Software Foundation, Inc., 59 Temple 
 *Place - Suite 330, Boston, MA 02111-1307, USA)
 */

package iiixzu.help.sql;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * SQL ۼ   ϴ Ŭ.
 * 
 * @author ̱ (<a href="mailto:iiixzu@gamil.com">iiixzu@gmail.com</a>)
 */
public class SqlHelper {
    /**
	 * Է ´.
	 * @param tableName ̺.
	 * @param parameters Ķ(÷)=   ̷ .
	 * @return  .
	 */
	public static String getInsertQuery(String tableName,Map parameters){
		
		Object[] column=parameters.keySet().toArray();
				
		String query="INSERT INTO "+tableName+"(";		
		for(int i=0;i<column.length;i++){
				query+=(String)column[i]+",";
		}
		query=query.substring(0,query.length()-1);
		query+=") VALUES(";
		for(int i=0;i<column.length;i++){
			query+="'"+parameters.get(column[i])+"',";
		}
		query=query.substring(0,query.length()-1);
		query+=")";
		
		return query;
	}
	/**
	 *  ´. ϳ Ű   ؼ Ѵ. 
	 * @param map û(÷= ).
	 * @param tableName ̺.
	 * @param where where   null.
	 * @return  .
	 */
	public static String getUpdateQuery(String tableName,Map map,String where){
		Object[] column=map.keySet().toArray();
		
		String query="UPDATE "+tableName+" SET ";
		
		for(int i=0;i<column.length;i++){
			query+=(String)column[i]+"='"+(String)map.get(column[i])+"',";
		}
		query=query.substring(0,query.length()-1);
		if(where!=null){
		    query+=" WHERE "+where;
		}		
		return query;
	}
	/**
	 *  ´.
	 * @param tableName ̺.
	 * @param where where   null.
	 * @return  .
	 */
	public static String getDeleteQuery(String tableName,String where){
	    
	    String query=null;
	    if(where!=null){
	        query="DELETE FROM "+tableName+" WHERE "+where;
	    }else{
	        query="DELETE FROM "+tableName;
	    }
		return query;
	}
	/**
	 * Update Ѵ. Statement ̿Ͽ ۾ Ѵ.
	 * 
	 * @param query ϱ⸦ ϴ .
	 * @param con Connectionü Connectionü ؼ  Ʈó ʴ´.
	 * @return ŵ row.
	 * @throws SQLException
	 */
	public static int executeUpdate(String query,Connection con)throws SQLException{
		Statement stmt=null;
		String query2=null;
		try {
			query2=query.toLowerCase().trim();
			
			//if(query.startsWith("update")||query.startsWith("delete")){
				stmt=con.createStatement();
				return stmt.executeUpdate(query2);
			//}else{
				//throw new SQLException("#I want only update or delete query");
			//}
		} finally{
			if(stmt!=null){stmt.close();}
		}
	}
	/**
	 * Select  Ѵ.
	 * @param query 
	 * @param con Connection ü Connectionü ؼ  Ʈó ʴ´.
	 * @return ITableRow List   null ϵȴ.
	 * @throws SQLException
	 */
	public static List executeQuery(String query,Connection con)throws SQLException{
		class Row implements ITableRow{
			boolean isExist;
			Map columnNames;
			Map map;
			
			public Row(){
				isExist=true;
				columnNames=new HashMap();
				map=new HashMap();
			}
			public boolean isExist(){
				return isExist;
			}
			public Object getColumns(String columnName){
				if(this.isExist()){
		    		return map.get(columnName.toLowerCase());
		    	}else{
		    		return null;
		    	}
			}
			public Object getColumns(int index){
				if(this.isExist()){
		    		int tempIndex=index-1;        
		    		return map.get(columnNames.get(tempIndex+""));
		    	}else{
		    		return null;
		    	}
			}
		}
		Statement stmt1=null;
		ResultSet resultSet1=null;
		Row data=null;
		ResultSetMetaData metaData1=null;
		int columnCount=0;
		List list=null;
		
		boolean isCreate=false;
		try {
			stmt1=con.createStatement();
			resultSet1=stmt1.executeQuery(query);			
			metaData1=resultSet1.getMetaData();
	        columnCount=metaData1.getColumnCount();
	        
			while(resultSet1.next()){
				if(!isCreate){
					list=new ArrayList();
					isCreate=true;
				}
				data=new Row();
				
				for(int i=0;i<columnCount;i++){
	                data.map.put(metaData1.getColumnName(i+1).toLowerCase(),resultSet1.getObject(i+1));             
	                data.columnNames.put(i+"",metaData1.getColumnName(i+1).toLowerCase());
	             }
				
				list.add(data);
			}
			return list;
		} finally{
			if(resultSet1!=null){resultSet1.close();}
			if(stmt1!=null){stmt1.close();}			
		}
	}
}
